version: v0.2.0
input:
  root: SysbenchCpuInputParams__PcpInputParams
  objects:
    SysbenchCpuInputParams__PcpInputParams:
      id: SysbenchCpuInputParams__PcpInputParams
      properties:
        constant:
          display:
            description: The parameters for the PCP workload
            name: PCP parameters
          type:
            type_id: ref
            id: PcpInputParams
            namespace: $.steps.pcp.starting.inputs.input
        item:
          display:
            description: The parameters for the sysbench workload
            name: sysbench parameters
          type:
            type_id: ref
            id: SysbenchCpuInputParams
            namespace: $.steps.sysbench.starting.inputs.input
          required: true

steps:
  # Generate a UUID for the workflow
  uuidgen:
    plugin:
      deployment_type: image
      src: quay.io/arcalot/arcaflow-plugin-utilities:0.7.0
    step: uuid
    input: {}

  # Start the PCP data collection
  pcp:
    plugin:
      deployment_type: image
      src: quay.io/arcalot/arcaflow-plugin-pcp:0.10.1
    step: run-pcp
    deploy:
      deployer_name: podman
      deployment:
        host:
          NetworkMode: host
          Binds:
            - /etc/system-release:/etc/system-release
    input: !expr $.input.constant
    closure_wait_timeout: 60000
    # Stop the PCP data collection after the post_wait step completes
    stop_if: !expr $.steps.post_wait.outputs

  # Wait the specified milliseconds before starting the sysbench workload
  pre_wait:
    plugin:
      deployment_type: image
      src: quay.io/arcalot/arcaflow-plugin-utilities:0.7.0
    step: wait
    input:
      wait_time_ms: 10000
    # Don't start this step until after the pcp step has started
    wait_for: !expr $.steps.pcp.starting.started

  # Start the sysbench workload
  sysbench:
    plugin:
      deployment_type: image
      src: quay.io/arcalot/arcaflow-plugin-sysbench:0.8.0
    step: sysbenchcpu
    input: !expr $.input.item
    # Don't start this step until after the pre_wait has completed
    wait_for: !expr $.steps.pre_wait.outputs

  # Wait the specified milliseconds after the sysbench workload succeeds
  post_wait:
    plugin:
      deployment_type: image
      src: quay.io/arcalot/arcaflow-plugin-utilities:0.7.0
    step: wait
    input:
      wait_time_ms: 10000
    # Don't start this step until after the sysbench step completes
    wait_for: !expr $.steps.sysbench.outputs

outputs:
  success:
    sample_uuid: !expr $.steps.uuidgen.outputs.success.uuid
    test_results: !expr $.steps.sysbench.outputs.success
    pcp_time_series: !expr $.steps.pcp.outputs.success.pcp_output
